SystemOrganization addCategory: #'LRSTM-Benchmarks'!

BenchmarkGameSuite subclass: #LRSTMBenchmarkGameSuite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Benchmarks'!

!LRSTMBenchmarkGameSuite methodsFor: 'utilities' stamp: 'StefanMarr 1/13/2013 18:32'!
adopt: obj
	Smalltalk at: #LRSTMDomain ifPresent: [:dom |
		^ dom domain adoptObject: obj].
	^ obj! !

!LRSTMBenchmarkGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/6/2013 23:08'!
benchAtomicBinaryTrees
	| result problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
							            ifNil: [ OstBGBinaryTrees defaultProblemSize ].

	[ | bench |
	  bench  := OstBGBinaryTrees new.
	  result := bench binarytrees: problemSize to: (TextStream with: String new).
	] atomic.

	^ result! !

!LRSTMBenchmarkGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/6/2013 23:08'!
benchAtomicChameleons
	| result problemSize |
	
	self error: 'This benchmark seems to be currently broken in the OmniST implementation.'.
	
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								         ifNil: [ OstBGChameleons defaultProblemSize ].
	
	[ result := OstBGChameleons chameneos: problemSize ] atomic.

	^ result! !

!LRSTMBenchmarkGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/6/2013 23:08'!
benchAtomicChameneosRedux
	| result report problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								         ifNil: [ OstBGChameneosRedux defaultProblemSize ].	

	[report := TextStream with: String new.
	 result := OstBGChameneosRedux new runBenchMark: problemSize on: report
	] atomic.

	^ result! !

!LRSTMBenchmarkGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/5/2013 22:15'!
benchAtomicFannkuchRedux
	| result report problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								         ifNil:    [ OstBGFannkuchRedux defaultProblemSize ].
	

	[report := TextStream with: String new.
	 result := OstBGFannkuchRedux fannkuchRedux: problemSize to: report
	] atomic.

	^ result! !

!LRSTMBenchmarkGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/5/2013 22:16'!
benchAtomicFasta
	| out problemSize |
	problemSize := self problemSize
		ifNotNilDo: [:ps | ps ]
		ifNil:      [ OstBGFasta defaultProblemSize ].  
	
	[out := TextStream with: String new.
	 OstBGFasta fasta: problemSize to: out. ] atomic.

	^ out
! !

!LRSTMBenchmarkGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/7/2013 14:51'!
benchAtomicKNucleotide
	| bench input result problemSize output |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
							            ifNil:    [ OstBGKNucleotide defaultProblemSize ].
	
	[bench  := OstBGKNucleotide new.
	 input  := ReadStream on: (BGFastaCache forFasta: problemSize).
	 result := TextStream with: String new.
	 output := bench knucleotide5From: input to: result.
	] atomic.

	^ output! !

!LRSTMBenchmarkGameSuite methodsFor: 'utilities' stamp: 'StefanMarr 5/6/2013 23:07'!
benchAtomicMandelbrot
	| result bench problemSize |
	bench := OstBGMandelbrot new.
	problemSize := self problemSize ifNotNil: [:ps | ps ]
							            ifNil:    [ OstBGMandelbrot defaultProblemSize ].
							
	[ result := OstArray new: problemSize * problemSize / 8.
	  bench mandelbrot2: problemSize to: result.
	] atomic.

	^ result! !

!LRSTMBenchmarkGameSuite methodsFor: 'utilities' stamp: 'StefanMarr 5/6/2013 23:08'!
benchAtomicMeteor
	| problemSize result |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								  ifNil: [ OstBGMeteor defaultProblemSize ].
	
	[result := OstBGMeteor meteor: problemSize] atomic.
	^ result! !

!LRSTMBenchmarkGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/6/2013 23:08'!
benchAtomicNBody
	| problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								         ifNil: [ OstBGNBody defaultProblemSize ].

	[ OstBGNBody nbody: problemSize ] atomic! !

!LRSTMBenchmarkGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/6/2013 23:10'!
benchAtomicPiDigits
	| result problemSize |
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								         ifNil:    [ OstBGPiDigits defaultProblemSize ].
	[ result := OstBGPiDigits piDigits: problemSize ] atomic.

	^ result! !

!LRSTMBenchmarkGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/7/2013 20:47'!
benchAtomicRegexDNA
	| problemSize |
	problemSize := self problemSize
		ifNotNil: [:ps | ps ]
		ifNil:    [ OstBGRegexDNA defaultProblemSize ].
	
	[OstBGRegexDNA regexdna: problemSize] atomic.! !

!LRSTMBenchmarkGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/7/2013 20:47'!
benchAtomicReverseComplement
	| problemSize |
	problemSize := self problemSize
		ifNotNil: [:ps | ps ]
		ifNil:    [ BGReverseComplement defaultProblemSize ].
	
	[BGReverseComplement revcomp: problemSize] atomic.! !

!LRSTMBenchmarkGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/7/2013 20:47'!
benchAtomicSpectralNorm
	| bench problemSize result |
	bench := OstBGSpectralNorm new.
	problemSize := self problemSize ifNotNil: [:ps | ps ]
							            ifNil:    [ OstBGSpectralNorm defaultProblemSize ].

	[ result := bench spectralnorm: problemSize ] atomic.

	^ result! !

!LRSTMBenchmarkGameSuite methodsFor: 'benchmarking' stamp: 'StefanMarr 5/7/2013 20:48'!
benchAtomicThreadRing
	| problemSize result |
	
	self error: 'currently not supported.'.
	
	problemSize := self problemSize ifNotNil: [:ps | ps ]
								  ifNil: [ BGThreadRing defaultProblemSize ].

	[ result := BGThreadRing threadring: problemSize ]  atomic.

	^ result! !

SMarkCompiler subclass: #LRSTMBenchCompiler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Benchmarks'!

!LRSTMBenchCompiler methodsFor: 'benchmarking' stamp: 'StefanMarr 5/8/2013 14:04'!
benchCompiler
	[super benchCompiler] atomic! !

SMarkLoops subclass: #LRSTMBenchLoops
	instanceVariableNames: 'omniDomain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Benchmarks'!

!LRSTMBenchLoops class methodsFor: 'class initialization' stamp: 'StefanMarr 9/8/2012 09:26'!
initialize
	OstObject omnifyClass: self.! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 1/30/2013 13:47'!
adopt: obj
	Smalltalk at: #LRSTMDomain ifPresent: [:dom |
		^ dom domain adoptObject: obj].
	^ obj! !

!LRSTMBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 9/12/2012 13:24'!
benchArrayAccess
	| i array obj |
	
	array := OstArray new: 1.
	obj   := OstObject new.
	
	i := self problemSize.
	[i > 0] whileTrue: [
		array at: 1.
		array at: 1 put: obj.
		
		i := i - 1.
	].! !

!LRSTMBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 1/10/2012 10:42'!
benchAtomicArrayAccess
	[ self benchArrayAccess ] atomic.! !

!LRSTMBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 1/10/2012 10:27'!
benchAtomicClassVarBinding
	[ self benchClassVarBinding ] atomic.! !

!LRSTMBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 12/4/2011 12:04'!
benchAtomicFloatLoop
	[ self benchFloatLoop ] atomic.! !

!LRSTMBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 1/10/2012 10:29'!
benchAtomicInstVarAccess
	[ self benchInstVarAccess ] atomic.! !

!LRSTMBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 12/4/2011 12:04'!
benchAtomicIntLoop
	[ self benchIntLoop ] atomic.! !

!LRSTMBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 1/10/2012 10:37'!
benchAtomicSend
	[ self benchSend ] atomic.! !

!LRSTMBenchLoops methodsFor: 'benchmarking' stamp: 'StefanMarr 1/10/2012 10:38'!
benchAtomicSendWithManyArguments
	[ self benchSendWithManyArguments ] atomic.! !

!LRSTMBenchLoops methodsFor: 'initialize-release' stamp: 'StefanMarr 1/13/2013 17:45'!
initialize
	super initialize.
	self adopt: self.! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 8/29/2012 18:03'!
omniDomain
	<omniUnenforced>
	^ omniDomain! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 1/3/2012 14:04'!
omniDomain: aDomain
	omniDomain := aDomain! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 7/18/2012 22:14'!
requestExecutionOf: aSelector
	<omniUnenforced>
	^ omniDomain requestExecutionOf: aSelector on: self.! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 7/18/2012 22:14'!
requestExecutionOf: aSelector lookup: cls
	<omniUnenforced>
	^ omniDomain requestExecutionOf: aSelector lookup: cls on: self.! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 7/18/2012 22:14'!
requestExecutionOf: aSelector with: p1
	<omniUnenforced>
	^ omniDomain requestExecution: p1 of: aSelector on: self! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 7/18/2012 22:14'!
requestExecutionOf: aSelector with: p1 with: p2
	<omniUnenforced>
	^ omniDomain requestExecution: p1 with: p2 of: aSelector on: self! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 7/18/2012 22:14'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3
	<omniUnenforced>
	^ omniDomain
		requestExecution: p1
		with: p2
		with: p3
		of: aSelector
		on: self! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 7/18/2012 22:14'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4
	<omniUnenforced>
	^ omniDomain
		requestExecution: p1
		with: p2
		with: p3
		with: p4
		of: aSelector
		on: self! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 7/18/2012 22:14'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5
	<omniUnenforced>
	^ omniDomain
		requestExecution: p1
		with: p2
		with: p3
		with: p4
		with: p5
		of: aSelector 
		on: self! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 7/18/2012 22:14'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6
	<omniUnenforced>
	^ omniDomain
		requestExecution: p1
		with: p2
		with: p3
		with: p4
		with: p5
		with: p6
		of: aSelector
		on: self! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 7/18/2012 22:13'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7
	<omniUnenforced>
	^ omniDomain
		requestExecution: p1
		with: p2
		with: p3
		with: p4
		with: p5
		with: p6
		with: p7
		of: aSelector
		on: self! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 7/18/2012 22:13'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8
	<omniUnenforced>
	^ omniDomain requestExecutionOf: aSelector on: self with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 7/18/2012 22:13'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9
	<omniUnenforced>
	^ omniDomain requestExecutionOf: aSelector on: self with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9! !

!LRSTMBenchLoops methodsFor: 'omni reflection' stamp: 'StefanMarr 7/18/2012 22:13'!
requestExecutionOf: aSelector with: p1 with: p2 with: p3 with: p4 with: p5 with: p6 with: p7 with: p8 with: p9 with: p10
	<omniUnenforced>
	^ omniDomain
		requestExecution: p1
		with: p2
		with: p3
		with: p4
		with: p5
		with: p6
		with: p7
		with: p8 with: p9 with: p10
		of: aSelector
		on: self! !

OstTestCase subclass: #LRSTMBenchmarkTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'LRSTM-Benchmarks'!

!LRSTMBenchmarkTest methodsFor: 'tests' stamp: 'StefanMarr 1/10/2012 12:34'!
testAtomicBinaryTrees
	LRSTMBenchmarkGameSuite new benchAtomicBinaryTrees! !

!LRSTMBenchmarkTest methodsFor: 'tests' stamp: 'StefanMarr 5/7/2013 14:41'!
testAtomicChameleons
	LRSTMBenchmarkGameSuite new benchAtomicChameleons! !

!LRSTMBenchmarkTest methodsFor: 'tests' stamp: 'StefanMarr 5/7/2013 14:41'!
testAtomicChameneosRedux
	LRSTMBenchmarkGameSuite new benchAtomicChameneosRedux! !

!LRSTMBenchmarkTest methodsFor: 'tests' stamp: 'StefanMarr 1/10/2012 12:34'!
testAtomicFannkuchRedux
	LRSTMBenchmarkGameSuite new benchAtomicFannkuchRedux! !

!LRSTMBenchmarkTest methodsFor: 'tests' stamp: 'StefanMarr 1/10/2012 12:35'!
testAtomicFasta
	LRSTMBenchmarkGameSuite new benchAtomicFasta! !

!LRSTMBenchmarkTest methodsFor: 'tests' stamp: 'StefanMarr 5/7/2013 14:42'!
testAtomicKNucleotide
	LRSTMBenchmarkGameSuite new benchAtomicKNucleotide! !

!LRSTMBenchmarkTest methodsFor: 'tests' stamp: 'StefanMarr 1/10/2012 12:35'!
testAtomicNBody
	LRSTMBenchmarkGameSuite new benchAtomicNBody ! !

Object subclass: #LRSTMBenchmark
	instanceVariableNames: ''
	classVariableNames: 'Value'
	poolDictionaries: ''
	category: 'LRSTM-Benchmarks'!

LRSTMBenchmark class
	instanceVariableNames: 'value mutex doneCount'!

LRSTMBenchmark class
	instanceVariableNames: 'value mutex doneCount'!

!LRSTMBenchmark class methodsFor: 'utilities' stamp: 'lr 5/30/2007 16:10'!
benchmark: aOriginalBlock reference: aReferenceBlock label: aString
	"Assert that aFastBlock is executed faster than aSlow block. The two blocks should be relatively fast and have no side effects, as they are executed multiple times."
	
	| originalTime referenceTime |
	originalTime := aOriginalBlock timeToRun.
	referenceTime := aReferenceBlock timeToRun.
	Transcript 
		show: aString; tab;
		show: ((referenceTime / 1000.0) roundTo: 0.01); tab;
		show: ((originalTime / 1000.0) roundTo: 0.01); tab;
		show: ((originalTime / referenceTime) asFloat roundTo: 0.01); cr! !

!LRSTMBenchmark class methodsFor: 'benchmarks' stamp: 'lr 5/30/2007 16:16'!
benchmarkActivation
	"self benchmarkActivation"
	
	self 
		benchmark: [ 10000000 timesRepeat: [ [ ] atomic ] ]
		reference: [ 10000000 timesRepeat: [ [ ] value ] ]
		label: 'Activation'! !

!LRSTMBenchmark class methodsFor: 'benchmarks' stamp: 'lr 5/30/2007 16:17'!
benchmarkBinding
	"self benchmarkBinding"

	self
		benchmark: [ [ 10000000 timesRepeat: [ Value ] ] atomic. [] value ]
		reference: [ [] atomic. [ 10000000 timesRepeat: [ Value ] ] value ]
		label: 'Binding Read'.
	self
		benchmark: [ [ 10000000 timesRepeat: [ Value := nil ] ] atomic. [] value ]
		reference: [ [] atomic. [ 10000000 timesRepeat: [ Value := nil ] ] value ]
		label: 'Binding Write'.! !

!LRSTMBenchmark class methodsFor: 'benchmarks' stamp: 'lr 5/30/2007 16:17'!
benchmarkInstance
	"self benchmarkInstance"
	
	self 
		benchmark: [ [ 10000000 timesRepeat: [ value ] ] atomic. [] value ]
		reference: [ [] atomic. [ 10000000 timesRepeat: [ value ] ] value ]
		label: 'Instance Read'.
	self
		benchmark: [ [ 10000000 timesRepeat: [ value := nil ] ] atomic. [] value ]
		reference: [ [] atomic. [ 10000000 timesRepeat: [ value := nil ] ] value ]
		label: 'Instance Write'! !

!LRSTMBenchmark class methodsFor: 'btree' stamp: 'StefanMarr 1/4/2012 15:39'!
benchmarkParallel
	"self benchmarkParallel"

	| semaphore data doneCnt repeatCount time btreeCls |
	semaphore := Semaphore forMutualExclusion.
	btreeCls := Smalltalk at: #BTree.
	
	1 to: 70 do: [ :processCount |
		Smalltalk garbageCollect.
		
		data := btreeCls new.
		doneCnt := 0.
		repeatCount := 500.
	
		processCount timesRepeat: [
			[ repeatCount timesRepeat: [ self twoAtomicUpdates: data ].
			  semaphore critical: [ doneCnt := doneCnt + 1 ] ]
				forkAt: Processor activeProcess priority ].
		time := [
			[ doneCnt < processCount ]
				whileTrue: [ Processor yield ] ]
			timeToRun.

		Transcript show: processCount; tab; show: time; cr ]! !

!LRSTMBenchmark class methodsFor: 'benchmarks' stamp: 'lr 5/30/2007 16:17'!
benchmarkSend
	"self benchmarkSend"
	
	self
		benchmark: [ [ 10000000 timesRepeat: [ nil flag: #zork ] ] atomic. [] value ]
		reference: [ [] atomic. [ 10000000 timesRepeat: [ nil flag: #zork ] ] value ]
		label: 'Message invokation'.
	self
		benchmark: [ [ 10000000 timesRepeat: [ nil flag: #zork ] ] atomic. [] value ]
		reference: [ [] atomic. [ 10000000 timesRepeat: [ 1 + 2 ] ] value ]
		label: 'Message invokation (fast)'! !

!LRSTMBenchmark class methodsFor: 'benchmarks' stamp: 'lr 5/30/2007 16:18'!
benchmarkVariable
	"self benchmarkVariable"

	self 
		benchmark: [ [ 10000000 timesRepeat: [ #( nil ) at: 1 ] ] atomic. [] value ]
		reference: [ [] atomic. [ 10000000 timesRepeat: [ #( nil ) at: 1 ] ] value ]
		label: 'Variable Read'.
	self
		benchmark: [ [ 10000000 timesRepeat: [ #( nil ) at: 1 put: nil ] ] atomic. [] value ]
		reference: [ [] atomic. [ 10000000 timesRepeat: [ #( nil ) at: 1 put: nil ] ] value ]
		label: 'Variable Write'! !

!LRSTMBenchmark class methodsFor: 'btree' stamp: 'lr 5/31/2007 17:11'!
twoAtomicUpdates: aDictionary
	[ [ aDictionary 
		at: SmallInteger maxVal atRandom put: 0;
		at: SmallInteger maxVal atRandom put: 0 ]
			atomic ]
		on: LRSTMConflict
		do: [ self twoAtomicUpdates: aDictionary ]! !

!LRSTMBenchmark class methodsFor: 'btree' stamp: 'lr 6/1/2007 11:01'!
twoMutexUpdates: aDictionary
	mutex critical: [
		aDictionary
			at: SmallInteger maxVal atRandom put: 0;
			at: SmallInteger maxVal atRandom put: 0 ]! !
LRSTMBenchLoops initialize!
